"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isArrayOfImarketCodes_1 = __importDefault(require("../../../src/functions/isArrayOfImarketCodes"));
describe('isArrayOfImarketCodes', () => {
    it('should return true for an array of valid ImarketCodes objects', () => {
        const validMarketCodesArray = [
            { market: 'KRW-BTC', korean_name: '비트코인', english_name: 'Bitcoin' },
            { market: 'KRW-ETH', korean_name: '이더리움', english_name: 'Ethereum' },
        ];
        expect((0, isArrayOfImarketCodes_1.default)(validMarketCodesArray)).toBe(true);
    });
    it('should return false for an array containing invalid ImarketCodes objects', () => {
        const invalidMarketCodesArray = [
            { market: 'KRW-BTC', korean_name: '비트코인', english_name: 'Bitcoin' },
            { market: 'KRW-ETH', korean_name: '이더리움' }, // missing english_name
        ];
        expect((0, isArrayOfImarketCodes_1.default)(invalidMarketCodesArray)).toBe(false);
    });
    it('should return false for a non-array value', () => {
        const notAnArray = {
            market: 'KRW-BTC',
            korean_name: '비트코인',
            english_name: 'Bitcoin',
        };
        expect((0, isArrayOfImarketCodes_1.default)(notAnArray)).toBe(false);
    });
    it('should return false for an empty array', () => {
        const emptyArray = [];
        expect((0, isArrayOfImarketCodes_1.default)(emptyArray)).toBe(false);
    });
});
