"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generateTrade_1 = __importDefault(require("../../generators/generateTrade"));
const updateQueueBuffer_1 = __importDefault(require("../../../src/functions/updateQueueBuffer"));
describe('updateQueueBuffer', () => {
    const trades = [
        (0, generateTrade_1.default)('AAPL'),
        (0, generateTrade_1.default)('AAPL'),
        (0, generateTrade_1.default)('AAPL'),
        (0, generateTrade_1.default)('AAPL'),
    ];
    it('should remove items from the beginning of the buffer if it exceeds the maximum size', () => {
        const maxSize = 3;
        const buffer = trades;
        const expected = trades.slice(1, 4);
        expect((0, updateQueueBuffer_1.default)(buffer, maxSize)).toEqual(expected);
    });
    it('should return an empty array if the buffer is empty', () => {
        const maxSize = 3;
        const buffer = [];
        const expected = [];
        expect((0, updateQueueBuffer_1.default)(buffer, maxSize)).toEqual(expected);
    });
    it('should return a copy of the buffer if it does not exceed the maximum size', () => {
        const maxSize = 3;
        const buffer = trades.slice(1, 3);
        const expected = trades.slice(1, 3);
        expect((0, updateQueueBuffer_1.default)(buffer, maxSize)).toEqual(expected);
    });
});
