"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const useFetchMarketCode_1 = __importDefault(require("../../../src/hooks/useFetchMarketCode"));
const React = __importStar(require("react"));
const react_1 = require("@testing-library/react");
require("@testing-library/jest-dom/extend-expect");
const debugTest = false;
const TestFetchMarketCodeComponent = () => {
    const { isLoading, marketCodes } = (0, useFetchMarketCode_1.default)({ debug: debugTest });
    return (React.createElement("div", null, isLoading ? (React.createElement("p", null, "Loading...")) : (marketCodes.length > 0 && (React.createElement("ul", { "data-testid": "market-codes" }, marketCodes.map((code, index) => (React.createElement("li", { key: index },
        code.market,
        " - ",
        code.korean_name,
        " - ",
        code.english_name))))))));
};
describe('useFetchMarketCode hook', () => {
    beforeEach(() => {
        jest.restoreAllMocks();
    });
    it('fetches and displays market codes', () => __awaiter(void 0, void 0, void 0, function* () {
        // Mock fetch response
        const mockMarketCodes = [
            {
                market: 'KRW-BTC',
                korean_name: '비트코인',
                english_name: 'Bitcoin',
            },
        ];
        jest.spyOn(global, 'fetch').mockResolvedValue({
            ok: true,
            text: () => Promise.resolve(JSON.stringify(mockMarketCodes)),
        });
        // Render the TestFetchMarketCodeComponent
        (0, react_1.render)(React.createElement(TestFetchMarketCodeComponent, null));
        // Check if the loading status is displayed
        const loadingStatus = react_1.screen.getByText(/Loading.../i);
        expect(loadingStatus).toBeInTheDocument();
        // Wait for the loading status to be removed
        yield (0, react_1.waitForElementToBeRemoved)(() => react_1.screen.queryByText(/Loading.../i));
        // Check if the market codes are displayed
        const marketCodesList = react_1.screen.getByTestId('market-codes');
        expect(marketCodesList).toBeInTheDocument();
        expect(marketCodesList.children.length).toBeGreaterThan(0);
    }));
    it('handles errors when fetching market codes', () => __awaiter(void 0, void 0, void 0, function* () {
        // Mock fetch response with error
        jest.spyOn(global, 'fetch').mockResolvedValue({
            ok: false,
            status: 500,
            statusText: 'Internal Server Error',
        });
        // Render the TestFetchMarketCodeComponent
        (0, react_1.render)(React.createElement(TestFetchMarketCodeComponent, null));
        // Check if the loading status is displayed
        const loadingStatus = react_1.screen.getByText(/Loading.../i);
        expect(loadingStatus).toBeInTheDocument();
        // Wait for the loading status to be removed
        yield (0, react_1.waitForElementToBeRemoved)(() => react_1.screen.queryByText(/Loading.../i));
        // Check if the market codes list is empty
        const marketCodesList = react_1.screen.queryByTestId('market-codes');
        expect(marketCodesList).not.toBeInTheDocument();
    }));
});
